!#************************************************************************
!# E.S.O. - 3.60 Upgrade Project
!#
!# who		when		what
!# ----------	--------	------------------------
!# p.leisy	981115		VLT Software adaptation
!# kbanse	100111		implement verifications
!# kbanse	100407		last modif
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++
!#   NAME:	EXTDrawSlit
!# 
!#   SYNOPSIS:	EXTDrawSlit Xslit Yslit SLITwidth
!#   
!#   DESCRIPTION:	
!#   Draw the current slit
!#    
!#   ENVIRONMENT:	
!#   PCO must be running together with a background MIDAS session	
!#------------------------------------------------------------------------
! PARAMETERS:
! P1 --> Image Name
! P2 --> Xslit
! P3 --> Yslit
! P4 --> SlitWidth
! borne --> slit limits
!
! EXTERNAL VARIABLES:
!
defi/par P1 ?    C "Name of frame: "
defi/par P2 1024 N "X position of the Slit :"
defi/par P3 ?    N "Y position of the Slit :"
defi/par P4 1.5  C "Slit width : [1.5 arcsec] " 
!
defi/loc radslit/r/1/1	{P4}
!
! New limits with the new Slit wheel
defi/loc borne/r/1/2 50,1900

defi/loc cmc/c/1/60	{P1}
defi/loc xslit/r/1/1	{P2}
defi/loc yslit/r/1/1	{P3}
!
write/out "Slit : {radslit} arcsec " 
outputr(1) = radslit
radslit = {radslit}/{imscale}
write/out "Slit : {radslit} pixels " 
outputr(2) = radslit
write/key rcorr 5.0,4.16667E+01
@@ kcompare draw010:rcorr outputr 1,2 0.005

define/local xsta/r/1/1   0
define/local ysta/r/1/1   0
define/local xend/r/1/1   0
define/local yend/r/1/1   0
define/local lowlex/i/1/1 0
define/local lowley/i/1/1 0
define/local uprigx/i/1/1 0
define/local uprigy/i/1/1 0

load {cmc} cuts=1200,2000 scale=-2
clear/ch ov 0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! calculate the positions of the slit and the center
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
indisk/fits {cmc} cc
xsta = {cc,START(1)}
ysta = {cc,START(2)}
xend = {cc,START(1)} + ({cc,NPIX(1)}-1) * {cc,STEP(1)}
yend = {cc,START(2)} + ({cc,NPIX(2)}-1) * {cc,STEP(2)}
!
lowlex = {xslit} - {radslit}/2.
uprigx = {xslit} + {radslit}/2.
lowley = {yslit} - {radslit}/2.
uprigy = {yslit} + {radslit}/2.
!*******************************************
! Check of the limits ... VERY IMPORTANT
!*******************************************
if lowlex .lt. {xsta} then
  lowlex = {xsta}
endif
if uprigx .gt. {xend} then
  uprigx = {xend}
endif
if lowley .lt. {ysta} then
  lowley = {ysta}
endif
if uprigy .gt. {yend} then
  uprigy = {yend}
endif
!
if borne(1) .lt. {xsta} then
  borne(1) = {xsta}
endif
if borne(2) .gt. {xend} then
  borne(2) = {xend}
endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! draw the slit
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

outputi(1) = borne(1)
outputi(2) = borne(2)
outputi(3) = lowlex
outputi(4) = lowley
outputi(5) = uprigx
outputi(6) = uprigy
write/keyw icorr 50,1900,979,979,1021,1021
@@ kcompare draw020:icorr outputi 1,6

draw/line {borne(1)},{lowley},{borne(2)},{lowley} F
draw/line {borne(1)},{uprigy},{borne(2)},{uprigy} F
draw/circle {lowlex},{lowley},{uprigx},{uprigy} F
! 
