! #************************************************************************
! # E.S.O. - 3.60 Upgrade Project
! #
! #
! # who		when		what
! # ----------	--------	------------------------
! 
!.VERSION
! 103019	last modif
! using FITS file for reference in rebin/rotate does not work
! in 10FEBpl1.0 ... but id does work in 07SEPpl1
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! Fits header of EFOSC2
! ESO DET CHIP1 ID = 'ccd40'
! 
! write/out "**************************************************"
! write/out " The image name is composed with 1 or 2 characters . "
! write/out "**************************************************"
! write/out " "

write/key distor/i/1/1 0	   ! NO distortion correction !

DEFI/LOC l/I/1/7	0
DEFI/LOC lp/I/1/7	0
DEFI/LOC inN/C/1/120	{P1}
DEFI/LOC long/I/1/1	0

write/key name/C/1/60 " "
write/out "inN = {inN}"

defi/loc nxs/i/1/1   {{inN},NAXIS}
defi/loc npx1/i/1/5  {{inN},NPIX(1)}
defi/loc npx2/i/1/5  {{inN},NPIX(2)}
defi/loc sta1/i/1/5  {{inN},START(1)}
defi/loc sta2/i/1/5  {{inN},START(2)} 
defi/loc step1/r/1/5 {{inN},ESO.DET.WIN1.BINX}
defi/loc step2/r/1/5 {{inN},ESO.DET.WIN1.BINY}

if {step1} .ne. {step2} then
   write/out " Wrong image x/y step. Don't use it to create MOS masks"
   errsum = errsum + 1
   return
endif

write/key wemmi/i/1/1 0

write/key exst/i/1/1 0

!
! Does the emmi CCD name descriptor exists ?
!

! IF  binning is 2x2   the name keyword is ESO.DET.CHIP2.NAME

wemmi = M$EXISTD("{p1}","ESO.DET.CHIP2.NAME") 
if wemmi .eq. 0  then 
   wemmi = M$EXISTD("{p1}","ESO.DET.CHIP1.NAME") 
   if wemmi .eq. 0 goto notrecognized
   write/key ccdname/c/1/6 {{p1},ESO.DET.CHIP1.NAME}
else
   write/key ccdname/c/1/6 {{p1},ESO.DET.CHIP2.NAME}
endif

exst = 1

write/out "ccd is {ccdname}"
!! ccd is LORAL
!! so this branch NOT taken
if ccdname .eq. "MIT/LL" then

  COMP/KEY l(1) = M$LEN(inN)
  COMP/KEY l(2) = M$LEN(inN)-5
  write/out
  write/out "MIT/LL Initial Name : {inN}"
  write/out
  l(3) = M$INDEX(inN,".fits")
  lp(3) = {l(3)}+1
  l(4) = {l(3)}-1

  write/out "l(2) : {l(2)}"
  write/out "l(3) : {l(3)}"
  write/out "l(4) : {l(4)}"
  
  write/out "inN : {inN} "
  
  DEFI/LOC nom/C/1/{l(4)} "{inN}"
  
  write/out "nom : {nom} "
  define/local len/i/1/1 0
  define/local min/i/1/1 0
  define/local deb/i/1/1 0
  define/local end/i/1/1 0
  len = M$LEN("{nom}")
  deb = M$INDEXB("{nom}","/") + 1
  end = M$INDEXB("{nom}",".") - 1
  min = len - 7
  if end .lt. min then
    end = len
  endif
  
  write/out "len: {len}  deb: {deb} end: {end}"
  write/key name/c/1/60 "{nom({deb}:{end})}.bdf"
  

! name = "{nom}.bdf"
  write/out "name : {name} "
  write/out "emmi ccd"

  write/out " inemmi Conversion of {p1} to a.bdf "
   
  @@ EXTinemmi {p1} a

  write/out " Rotation of a.bdf into {name} "
  read/des {name}
  
  return
endif
!!
!!
if ccdname .eq. "LORAL" then

  write/out "efosc ccd"

  COMP/KEY l(1) = M$LEN(inN)
  COMP/KEY l(2) = M$LEN(inN)-5
  write/out
  write/out "LORAL Initial Name : {inN}"
  write/out
  l(3) = M$INDEX(inN,".")
  lp(3) = {l(3)}+1
  l(4) = {l(3)}-1

  write/out "l(2) : {l(2)}"
  write/out "l(3) : {l(3)}"

  DEFI/LOC wc/C/1/60	" "

  IF l(2) .LT. l(3) THEN
    WRITE/KEY nume/C/1/1 "0"
    wc = "{inN}(7:11)0_R)"
  ELSE
    long = {l(2)}-{l(3)}
    WRITE/KEY nume/C/1/{long}	" "
    nume = "{inN({lp(3)}:{l(2)})}"
    IF long .EQ. 1 THEN
      wc = "{inN(7:11)}{nume}_R"
    ELSE
      IF long .EQ. 2 THEN
        wc = "{inN(7:10)}{nume}_R"
      ELSE
        wc = "{inN(7:9)}{nume}_R"
      ENDIF
    ENDIF
  ENDIF
  write/out "Chiffre : {long}"
  write/out "Nume : {nume}"

  write/out "inN : {inN} "
  
  wc = "{inN}"
  
  write/out "wc : {wc} "
  define/local len/i/1/1 0
  define/local min/i/1/1 0
  define/local deb/i/1/1 0
  define/local end/i/1/1 0
  len = M$LEN("{wc}")
  deb = M$INDEXB("{wc}","/") + 1
  end = len
  
  write/out "len: {len}  deb: {deb} end: {end}"
  write/key name/c/1/60 "abc.bdf"
  
  indisk/fits {p1} &xx			!needed for Midas > 07SEP ...

  write/out " Rotation of the Image => {name}"

  rebin/rota {p1} {name} -90 &xx

  write/out
  write/out "Final Name : {name}"
  write/out
  write/des {name} ESO.DET.ID/c/1/16   "ccd$40"
  write/des {name} ESO.DET.NAME/c/1/16 "ccd$40"
  write/des {name} CUNIT "                PIXEL              PIXEL"
  write/des {name} START 1.,1.

  write/des {name} STEP {step1},{step2}
  read/des {name}
  write/out " leaving fits2bdfR90"

  DELE/KEY nume
  return
endif

notrecognized:
! no CCD name in frame descriptors : degraded mode .
! or current image is not an  EMMI RED one.

!! @@ emobell
write/out "*********************************************"
write/out "*                                           *"
write/out "*                 CCD  is                   *"
write/out "*  neither LORAL (EFOSC) nor MIT/LL (EMMI)  *"
write/out "*  you cannot use Fits widget in this case  *"
write/out "*                                           *"
write/out "*********************************************"
write/out ""
write/out ""
!! @@ emobell
errsum = errsum + 1

